//+------------------------------------------------------------------+ 
//|                                  TrendStrength jurik channel.mq4 | 
//|                                                                  | 
//|                                         http://www.forextsd.com  |
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2010, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window 
#property indicator_buffers    4 
#property indicator_color1     DarkOrange
#property indicator_width1     2
#property indicator_color2     White
#property indicator_style2     STYLE_DASH
#property indicator_color3     Red
#property indicator_width3     1
#property indicator_color4     LimeGreen
#property indicator_width4     1
#property indicator_level1     0
#property indicator_levelcolor Violet

//
//
//
//
//

extern int    Price            = 0;
extern int    OmaLength        = 2;
extern double OmaSpeed         = 8.0;
extern bool   OmaAdaptive      = true;
extern int    HighLowPeriod    = 30;
extern bool   ShowChannel      = true;
extern bool   ShowZigZag       = true;

//
//
//
//
//

double ts[];
double zz[];
double hb[];
double lb[];
double zzlow[];
double zzhigh[];
double trend[];

//
//
//
//
//

int init() 
{ 
   IndicatorBuffers(7);  
     SetIndexBuffer(0,ts); SetIndexLabel(0,"TS"); 
     SetIndexBuffer(1,zz); SetIndexLabel(1, NULL);  SetIndexStyle(1,DRAW_SECTION);       
     SetIndexBuffer(2,hb);
     SetIndexBuffer(3,lb);
     SetIndexBuffer(4,zzlow);
     SetIndexBuffer(5,zzhigh);
     SetIndexBuffer(6,trend);
   
     SetIndexEmptyValue(0,0);
     SetIndexEmptyValue(1,0);
     SetIndexEmptyValue(4,0);
     SetIndexEmptyValue(5,0);
   
     if (ShowChannel)
     {
     SetIndexStyle(2,DRAW_LINE);
     SetIndexStyle(3,DRAW_LINE);
     }
     else      
     {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
     }
   
   
   IndicatorShortName("Oma TrendStrength channel"); 
   
return(0); 
} 

//
//
//
//
//

int deinit(){  return(0); } 

//
//
//
//
//

int start() 
{  
   int counted_bars=IndicatorCounted();
   int lastZag;
   int i,r,n,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1); 
         
   //
   //
   //
   //
   //
   
    
   if (ShowZigZag)
   for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;

       
       for(i=limit, r=Bars-i-1; i>=0; i--, r++)
       {
              double       tmp = iMA(NULL,0, 5,0, MODE_EMA,PRICE_CLOSE,i);     
              double ma1 = tmp - iMA(NULL,0,10,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma2 = tmp - iMA(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma3 = tmp - iMA(NULL,0,30,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma4 = tmp - iMA(NULL,0,40,0,MODE_SMMA,PRICE_CLOSE,i);  
              double ma5 = tmp - iMA(NULL,0,50,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma6 = tmp - iMA(NULL,0,60,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma7 = tmp - iMA(NULL,0,70,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma8 = tmp - iMA(NULL,0,80,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma9 = tmp - iMA(NULL,0,90,0,MODE_SMMA,PRICE_CLOSE,i);         
         
              ts[i] = iAverage((ma1+ma2+ma3+ma4+ma5+ma6+ma7+ma8+ma9)/9,OmaLength,OmaSpeed,OmaAdaptive,r,0);
              lb[i] = ts[ArrayMinimum(ts,HighLowPeriod,i)];
              hb[i] = ts[ArrayMaximum(ts,HighLowPeriod,i)];
          
              //
              //
              //
              //
              //
   
              trend[i] = trend[i+1];
              if (ts[i] > lb[i] && ts[i+1] <= lb[i+1]) trend[i] =  1;  
              if (ts[i] < hb[i] && ts[i+1] >= hb[i+1]) trend[i] = -1;
              
   //
   //
   //
   //
   //
   
   if (!ShowZigZag) continue;
      
              zzlow[i]  = 0;
              zzhigh[i] = 0;
              
              if (lb[i] < lb[i+1])
              {
                  if (zz[lastZag] == lb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  lb[i];
                      zzlow[i]    =  lb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (hb[i] > hb[i+1])
              {
                  if (zz[lastZag] == hb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  hb[i];
                      zzhigh[i]   =  hb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (zz[i] != 0)
              {
                  zz[i] = 0;
                  for (lastZag=i+1; lastZag<Bars; lastZag++)
                  {
                     if (zzlow[lastZag]  != 0) { zz[lastZag] = zzlow[lastZag];  break; }
                     if (zzhigh[lastZag] != 0) { zz[lastZag] = zzhigh[lastZag]; break; }
                  }
                  
              }
    
          }
   
    return(0); 
    }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double stored[][7];

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double const, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+const)/(1.0+const+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}


